//---------------------------------------------------------------------------------
//
// Generated Header File.  Do not edit by hand.
//    This file contains the state table for the ICU Rule Based Break Iterator
//    rule parser.
//    It is generated by the Perl script "rbbicst.pl" from
//    the rule parser state definitions file "rbbirpt.txt".
//
//   Copyright (C) 2002 International Business Machines Corporation 
//   and others. All rights reserved.  
//
//---------------------------------------------------------------------------------
#ifndef RBBIRPT_H
#define RBBIRPT_H

U_NAMESPACE_BEGIN
//
// Character classes for RBBI rule scanning.
//
    static const uint8_t kRuleSet_digit_char = 128;
    static const uint8_t kRuleSet_rule_char = 129;
    static const uint8_t kRuleSet_white_space = 130;
    static const uint8_t kRuleSet_name_char = 131;
    static const uint8_t kRuleSet_name_start_char = 132;


enum RBBI_RuleParseAction {
    doExprOrOperator,
    doRuleErrorAssignExpr,
    doTagValue,
    doEndAssign,
    doRuleError,
    doVariableNameExpectedErr,
    doRuleChar,
    doLParen,
    doSlash,
    doStartTagValue,
    doDotAny,
    doExprFinished,
    doScanUnicodeSet,
    doExprRParen,
    doStartVariableName,
    doTagExpectedError,
    doTagDigit,
    doUnaryOpStar,
    doEndVariableName,
    doNOP,
    doUnaryOpQuestion,
    doExit,
    doStartAssign,
    doEndOfRule,
    doUnaryOpPlus,
    doExprStart,
    doExprCatOperator,
    doReverseDir,
    doCheckVarDef,
    rbbiLastAction};

//-------------------------------------------------------------------------------
//
//  RBBIRuleTableEl    represents the structure of a row in the transition table
//                     for the rule parser state machine.
//-------------------------------------------------------------------------------
struct RBBIRuleTableEl {
    RBBI_RuleParseAction          fAction;
    uint8_t                       fCharClass;       // 0-127:    an individual ASCII character
                                                    // 128-255:  character class index
    uint8_t                       fNextState;       // 0-250:    normal next-stat numbers
                                                    // 255:      pop next-state from stack.
    uint8_t                       fPushState;
    UBool                         fNextChar;
};

static const struct RBBIRuleTableEl gRuleParseStateTable[] = {
    {doNOP, 0, 0, 0, TRUE}
    , {doExprStart, 254, 12, 8, FALSE}     //  1      start
    , {doNOP, 130, 1,0,  TRUE}     //  2 
    , {doExprStart, 36 /* $ */, 71, 81, FALSE}     //  3 
    , {doReverseDir, 33 /* ! */, 11,0,  TRUE}     //  4 
    , {doNOP, 59 /* ; */, 1,0,  TRUE}     //  5 
    , {doNOP, 252, 0,0,  FALSE}     //  6 
    , {doExprStart, 255, 12, 8, FALSE}     //  7 
    , {doEndOfRule, 59 /* ; */, 1,0,  TRUE}     //  8      break-rule-end
    , {doNOP, 130, 8,0,  TRUE}     //  9 
    , {doRuleError, 255, 86,0,  FALSE}     //  10 
    , {doExprStart, 255, 12, 8, FALSE}     //  11      reverse-rule
    , {doRuleChar, 254, 21,0,  TRUE}     //  12      term
    , {doNOP, 130, 12,0,  TRUE}     //  13 
    , {doRuleChar, 129, 21,0,  TRUE}     //  14 
    , {doNOP, 91 /* [ */, 77, 21, FALSE}     //  15 
    , {doLParen, 40 /* ( */, 12, 21, TRUE}     //  16 
    , {doNOP, 36 /* $ */, 71, 20, FALSE}     //  17 
    , {doDotAny, 46 /* . */, 21,0,  TRUE}     //  18 
    , {doRuleError, 255, 86,0,  FALSE}     //  19 
    , {doCheckVarDef, 255, 21,0,  FALSE}     //  20      term-var-ref
    , {doNOP, 130, 21,0,  TRUE}     //  21      expr-mod
    , {doUnaryOpStar, 42 /* * */, 26,0,  TRUE}     //  22 
    , {doUnaryOpPlus, 43 /* + */, 26,0,  TRUE}     //  23 
    , {doUnaryOpQuestion, 63 /* ? */, 26,0,  TRUE}     //  24 
    , {doNOP, 255, 26,0,  FALSE}     //  25 
    , {doExprCatOperator, 254, 12,0,  FALSE}     //  26      expr-cont
    , {doNOP, 130, 26,0,  TRUE}     //  27 
    , {doExprCatOperator, 129, 12,0,  FALSE}     //  28 
    , {doExprCatOperator, 91 /* [ */, 12,0,  FALSE}     //  29 
    , {doExprCatOperator, 40 /* ( */, 12,0,  FALSE}     //  30 
    , {doExprCatOperator, 36 /* $ */, 12,0,  FALSE}     //  31 
    , {doExprCatOperator, 46 /* . */, 12,0,  FALSE}     //  32 
    , {doExprCatOperator, 47 /* / */, 38,0,  FALSE}     //  33 
    , {doExprCatOperator, 123 /* { */, 50,0,  TRUE}     //  34 
    , {doExprOrOperator, 124 /* | */, 12,0,  TRUE}     //  35 
    , {doExprRParen, 41 /* ) */, 255,0,  TRUE}     //  36 
    , {doExprFinished, 255, 255,0,  FALSE}     //  37 
    , {doSlash, 47 /* / */, 40,0,  TRUE}     //  38      look-ahead
    , {doNOP, 255, 86,0,  FALSE}     //  39 
    , {doExprCatOperator, 254, 12,0,  FALSE}     //  40      expr-cont-no-slash
    , {doNOP, 130, 26,0,  TRUE}     //  41 
    , {doExprCatOperator, 129, 12,0,  FALSE}     //  42 
    , {doExprCatOperator, 91 /* [ */, 12,0,  FALSE}     //  43 
    , {doExprCatOperator, 40 /* ( */, 12,0,  FALSE}     //  44 
    , {doExprCatOperator, 36 /* $ */, 12,0,  FALSE}     //  45 
    , {doExprCatOperator, 46 /* . */, 12,0,  FALSE}     //  46 
    , {doExprOrOperator, 124 /* | */, 12,0,  TRUE}     //  47 
    , {doExprRParen, 41 /* ) */, 255,0,  TRUE}     //  48 
    , {doExprFinished, 255, 255,0,  FALSE}     //  49 
    , {doNOP, 130, 50,0,  TRUE}     //  50      tag-open
    , {doStartTagValue, 128, 53,0,  FALSE}     //  51 
    , {doTagExpectedError, 255, 86,0,  FALSE}     //  52 
    , {doNOP, 130, 57,0,  TRUE}     //  53      tag-value
    , {doNOP, 125 /* } */, 57,0,  FALSE}     //  54 
    , {doTagDigit, 128, 53,0,  TRUE}     //  55 
    , {doTagExpectedError, 255, 86,0,  FALSE}     //  56 
    , {doNOP, 130, 57,0,  TRUE}     //  57      tag-close
    , {doTagValue, 125 /* } */, 60,0,  TRUE}     //  58 
    , {doTagExpectedError, 255, 86,0,  FALSE}     //  59 
    , {doExprCatOperator, 254, 12,0,  FALSE}     //  60      expr-cont-no-tag
    , {doNOP, 130, 60,0,  TRUE}     //  61 
    , {doExprCatOperator, 129, 12,0,  FALSE}     //  62 
    , {doExprCatOperator, 91 /* [ */, 12,0,  FALSE}     //  63 
    , {doExprCatOperator, 40 /* ( */, 12,0,  FALSE}     //  64 
    , {doExprCatOperator, 36 /* $ */, 12,0,  FALSE}     //  65 
    , {doExprCatOperator, 46 /* . */, 12,0,  FALSE}     //  66 
    , {doExprCatOperator, 47 /* / */, 38,0,  FALSE}     //  67 
    , {doExprOrOperator, 124 /* | */, 12,0,  TRUE}     //  68 
    , {doExprRParen, 41 /* ) */, 255,0,  TRUE}     //  69 
    , {doExprFinished, 255, 255,0,  FALSE}     //  70 
    , {doStartVariableName, 36 /* $ */, 73,0,  TRUE}     //  71      scan-var-name
    , {doNOP, 255, 86,0,  FALSE}     //  72 
    , {doNOP, 132, 75,0,  TRUE}     //  73      scan-var-start
    , {doVariableNameExpectedErr, 255, 86,0,  FALSE}     //  74 
    , {doNOP, 131, 75,0,  TRUE}     //  75      scan-var-body
    , {doEndVariableName, 255, 255,0,  FALSE}     //  76 
    , {doScanUnicodeSet, 91 /* [ */, 255,0,  TRUE}     //  77      scan-unicode-set
    , {doScanUnicodeSet, 112 /* p */, 255,0,  TRUE}     //  78 
    , {doScanUnicodeSet, 80 /* P */, 255,0,  TRUE}     //  79 
    , {doNOP, 255, 86,0,  FALSE}     //  80 
    , {doNOP, 130, 81,0,  TRUE}     //  81      assign-or-rule
    , {doStartAssign, 61 /* = */, 12, 84, TRUE}     //  82 
    , {doNOP, 255, 20, 8, FALSE}     //  83 
    , {doEndAssign, 59 /* ; */, 1,0,  TRUE}     //  84      assign-end
    , {doRuleErrorAssignExpr, 255, 86,0,  FALSE}     //  85 
    , {doExit, 255, 86,0,  TRUE}     //  86      errorDeath
 };
static const char * const RBBIRuleStateNames[] = {    0,
     "start",
    0,
    0,
    0,
    0,
    0,
    0,
     "break-rule-end",
    0,
    0,
     "reverse-rule",
     "term",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
     "term-var-ref",
     "expr-mod",
    0,
    0,
    0,
    0,
     "expr-cont",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
     "look-ahead",
    0,
     "expr-cont-no-slash",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
     "tag-open",
    0,
    0,
     "tag-value",
    0,
    0,
    0,
     "tag-close",
    0,
    0,
     "expr-cont-no-tag",
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
     "scan-var-name",
    0,
     "scan-var-start",
    0,
     "scan-var-body",
    0,
     "scan-unicode-set",
    0,
    0,
    0,
     "assign-or-rule",
    0,
    0,
     "assign-end",
    0,
     "errorDeath",
    0};

U_NAMESPACE_END
#endif
